local def = {
	name = "explosive:explosion",
	description = "explosive Explosion (you hacker you!)",
	radius = 5,
	tiles = {
		side = "explosive_pow.png",
		top = "explosive_pow.png",
		bottom = "explosive_pow.png",
		burning = "explosive_pow.png"
	},
}

tnt.register_tnt(def)


minetest.register_craftitem("explosive:explosive", {
	description = "explosives(blows up a lot nodes)",
	range = 0,
	stack_max= 20,
	inventory_image = "explosive_explosive.png",
	on_use = function(itemstack, user, pointed_thing)
			if not minetest.setting_getbool("creative_mode") then itemstack:take_item()
		end
		if pointed_thing.type ~= "nothing" then
			local pointed = minetest.get_pointed_thing_position(pointed_thing)
			if vector.distance(user:getpos(), pointed) < 8 then
				return itemstack
			end
		end
		local pos = user:getpos()
		local dir = user:get_look_dir()
		local yaw = user:get_look_yaw()
		if pos and dir then
			pos.y = pos.y + 1.5
			local obj = minetest.add_entity(pos, "explosive:explosive")
			if obj then
				obj:setvelocity({x=dir.x * 15, y=dir.y * 15, z=dir.z * 15})
				obj:setacceleration({x=dir.x * -3, y=-10, z=dir.z * -3})
				obj:setyaw(yaw + math.pi)
				local ent = obj:get_luaentity()
				if ent then
					ent.player = ent.player or user
				end
			end
		end
		return itemstack
	end,
})


minetest.register_entity("explosive:explosive", {
	physical = true,
	collide_with_objects = true,
	collisionbox = {-0.25, -0.25, -0.25, 0.25, 0.25, 0.25},
	weight = 0,
	textures = {"explosive_explosive.png"},
	on_activate = function(self, staticdata)
		self.timer = 0
	end,
	on_step = function(self, dtime)
		local acc = self.object:getacceleration()
		self.object:setacceleration({x = acc.x * 1 / 1, y = acc.y, z = acc.z * 1 / 1})

		self.timer = self.timer + dtime
		if self.timer > 4 then
			tnt.boom(self.object:getpos(), def)
		end
	end,
})
